/*
   ----------------------------------------------------------------------------
   GetReport2.prg
   Sample code from The dBASE Reports Book, second edition
   Chapter 10
   Copyright  2016, Kenneth J. Mayer
   
   Program code to obtain a date range (using the GetDates.wfm form
   in this folder), uses a filter string to modify the report
   using the Preview.wfm form in the dUFLP.
   
   This may be used for other purposes, as needed. 
   ----------------------------------------------------------------------------
*/private oForm, dStart, dEnd, cFilter

// open the dialog:
set procedure to GetDates.wfm additive
oForm = new GetDatesForm()

// check the value returned by the form:
if oForm.readModal()
   // when the user closes the form:
   dStart = oForm.dStart
   dEnd = oForm.dEnd
   // create the filter string:
   cFilter = ""
   // if we have a start date:
   if not empty( dStart )
      cFilter := [Born =>']+dStart+[']
   endif // not empty( dStart )

   // if we have an end date:
   if not empty( dEnd )
      // if we already have something in the filter:
      if not empty( cFilter )
         cFilter += [ and ]
      endif // not empty( cFilter )
      cFilter += [Born <= ']+dEnd+[']
   endif // not empty( dEnd )

   // we need to create an instance of the report:
   set procedure to PreviewSample2.rep
   private rRep
   rRep = new PreviewSample2Report()
   // now we have this reference, we need to set the filter
   // on the rowset:
   rRep.streamSource1.rowset.filter := cFilter

   // Next, we need to set up the Preview form:
   set procedure to :dUFLP:Preview.wfm additive
   oPreview = new PreviewForm()
   // set the Modal property:
   oPreview.bModal = true
   // set the reportViewer ref property to point to the
   // report object:
   oPreview.Viewer.ref := rRep

   // open it:
   oPreview.readModal()

   // cleanup - once the Preview form closes:
   oPreview.release()
   close procedure :dUFLP:Preview.wfm
endif // oForm.readModal()

// clean up memory:
oForm.release()
close procedure GetDates.wfm
