/*
   ----------------------------------------------------------------------------
   DetailSummary.prg
   Sample code from The dBASE Reports Book, second edition
   Chapter 13
   Copyright  2016, Kenneth J. Mayer
   
   Program used to generate either a detail report or a summary 
   report based on user input (via the msgbox() function).
   
   This may be used for other purposes, as needed. 
   ----------------------------------------------------------------------------
*/
set procedure to DetailSummary.rep additive
local oRep, nAns

// create an instance of the report:
oRep = new DetailSummaryReport()

// ask the user what they want to do:
nAns = msgbox( "Do you want to show a Summary only?",;
               "Please Confirm", 36 )

if nAns == 6 // Yes
   // Summary only:
   oRep.streamSource1.detailBand.visible := false
   // get the column headings:
   oRep.streamSource1.group1.headerBand.DataHeadingText2.visible := false
   oRep.streamSource1.group1.headerBand.DataHeadingText3.visible := false
   oRep.pageTemplate1.SecondaryTitleText1.text := "Summary Report"
else // user selected "No" button
   // Detail report:
   oRep.pageTemplate1.SecondaryTitleText1.text := "Detail Report"
endif

// render the report:
oRep.render()
